from subprocess import call
import os, glob

def unescape_backslashes(filename):
    replaced = None
    with open(filename, 'r') as readfile:
        replaced = readfile.read() 
    
    replaced = replaced.replace("\\\\", "\\")
    with open(filename, 'w') as writefile:
        writefile.write(replaced)


#  The spreadsheets have some empty collumns with no specified locale, for which the l10n also generates JSON files so we delete them
#  YES! the proper solution is to edit the l10n script and this my friend, you are welcome to do yourself, there be dragons
def remove_invalid_files():
    for f in glob.glob("*-.*"):
        os.remove(f)

# ======================
os.chdir('displays/20x4')

call(['l10n', 'link', '11sA-J4NW-MqeCcEpxf09qtj1K5s4m50_iT0WlNq8gVo'])
call(['l10n', 'export', '--prefix', 'prompts-20x4-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

call(['l10n', 'link', '1gVQeruGuJaXBEpDDeCEXj6bhO5EeDVE323b9vIvgosU'])
call(['l10n', 'export', '--prefix', 'reasons-20x4-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

remove_invalid_files()

# ======================
os.chdir('../40x2')

call(['l10n', 'link', '1_qLU-dgAfADWF31Aj1wxLaxYxCJox3BVfgqGh_ZpIXE'])
call(['l10n', 'export', '--prefix', 'prompts-40x2-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

call(['l10n', 'link', '1aq0_dHJE5ylfxbkC_pYrvboq01Ac4CA_1_S8QvN0RqE'])
call(['l10n', 'export', '--prefix', 'reasons-40x2-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

remove_invalid_files()

# ======================
os.chdir('../vipa')

call(['l10n', 'link', '1o01p_r3B13vP8NmORXgouJJhLJBGHZK_BMpRO_ueWMU'])
call(['l10n', 'export', '--prefix', 'prompts-vipa-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

call(['l10n', 'link', '1X6ISpmWszcQLs7kyxZcZuOYyjv_nN5ZlOfkKvgfT49I'])
call(['l10n', 'export', '--prefix', 'reasons-vipa-', '--split', '--split_prefix', 'localization', '--fallback', 'en_US'])

remove_invalid_files()

# The VIPA exports contain escaped backslash \\ sequences (because they include newlines in the spreadsheet)
# We re just removing them inline so that this does not create any problems in the SDK

for file in glob.glob("prompts-vipa*.json"):
    unescape_backslashes(file)

for file in glob.glob("reasons-vipa*.json"):
    unescape_backslashes(file)

call('../../overwrite_unsupported_vipa.sh')

# ======================

os.chdir('../../errors/40x1')

call(['l10n', 'link', '1kUeHGDv8i33dcJBljmO6q6yZHNMHB3GLx960P1wFGYc'])
call(['l10n', 'export', '--fallback', 'en_US', '--prefix', 'errors-40x1-', '--split', '--split_prefix', 'localization'])

remove_invalid_files()

# ======================
